/*
*     ---------------------------------------------------------------------
*     Covariogram-based CS data gathering & compression framework
*     ---------------------------------------------------------------------
*     Performance evaluation framework including:
*               - generation of correlated spatio-temporal signals
*               - scheduling, sampling & data gathering
*               - signal compression (at the sensors) & reconstruction (at the sink)
*
*     Copyright (C) 2016 Mohsen Hooshmand, Davide Zordan, Michele Rossi
*     Department of Information Engineering, University of Padova, Italy
*     Email: {hooshmand, zordan, rossi}@dei.unipd.it
*
*     This program is free software: you can redistribute it and/or modify
*     it under the terms of the GNU General Public License as published by
*     the Free Software Foundation, either version 3 of the License, or
*     (at your option) any later version.
*
*     This program is distributed in the hope that it will be useful,
*     but WITHOUT ANY WARRANTY; without even the implied warranty of
*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*     GNU General Public License for more details.
*
*     You should have received a copy of the GNU General Public License
*     along with this program in the file "gpl-license-3.0.txt".
*
*     If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _FUNCSEARCH_H_
#define _FUNCSEARCH_H_

void brent(double ax, double bx, double cx, double tol, int distLng, double distances[], double corValue[], double output[], double scalar, int flag);
double mseComputation(double a, double b, double distances[], double corValue[], int distLng);

#endif
