%%
%     ---------------------------------------------------------------------
%     Covariogram-based CS data gathering & compression framework
%     ---------------------------------------------------------------------
%     Performance evaluation framework including:
%               - generation of correlated spatio-temporal signals
%               - scheduling, sampling & data gathering
%               - signal compression (at the sensors) & reconstruction (at the sink)
%
%     Copyright (C) 2016 Mohsen Hooshmand, Davide Zordan, Michele Rossi
%     Department of Information Engineering, University of Padova, Italy
%     Email: {hooshmand, zordan, rossi}@dei.unipd.it
%
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
%
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
%
%     You should have received a copy of the GNU General Public License
%     along with this program in the file "gpl-license-3.0.txt".
%
%     If not, see <http://www.gnu.org/licenses/>.
%%

function [cr,rmse,n_op,rec_x,max_error] = ltc_encoder_main(x,tol)
%------------------------------------------------------------------
% Enhanced PLAMLIS
%------------------------------------------------------------------
N = length(x);
n_op = 0;
%------------------------------------------------------------------

[model_f n_f n_op] = ltc_encoder(x,tol);
[rec_x]=ltc_decoder(model_f,n_f,N);

rec_x = rec_x(1:N);
cr = (n_f*size(model_f,2))/N;
max_error = max(abs(x-rec_x));
max_error = max(sqrt((x-rec_x).^2));
rmse = sqrt(mean((x-rec_x).^2));

